VTK: vtkSplineWidget Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Types | Protected Member Functions | Static Protected Member Functions | Protected Attributes | List of all members
vtkSplineWidget Class Reference

3D widget for manipulating a spline More...

`#include <vtkSplineWidget.h>`

Inheritance diagram for vtkSplineWidget:
[legend]
Collaboration diagram for vtkSplineWidget:
[legend]

## Public Types
typedef vtk3DWidget | Superclass
Public Types inherited from vtk3DWidget
typedef vtkInteractorObserver | Superclass
Public Types inherited from vtkInteractorObserver
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkSplineWidget * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | SetPlaneSource (vtkPlaneSource *plane)
| Set up a reference to a vtkPlaneSource that could be from another widget object, e.g. More...
virtual void | SetProjectionNormal (int)
virtual int | GetProjectionNormal ()
void | SetProjectionNormalToXAxes ()
void | SetProjectionNormalToYAxes ()
void | SetProjectionNormalToZAxes ()
void | SetProjectionNormalToOblique ()
void | GetPolyData (vtkPolyData *pd)
| Grab the polydata (including points) that defines the spline. More...
int | IsClosed ()
| Convenience method to determine whether the spline is closed in a geometric sense. More...
double | GetSummedLength ()
| Get the approximate vs. More...
void | InitializeHandles (vtkPoints *points)
| Convenience method to allocate and set the handles from a vtkPoints instance. More...
void | SetEnabled (int) override
| Methods that satisfy the superclass' API. More...
void | PlaceWidget (double bounds[6]) override
| Methods that satisfy the superclass' API. More...
void | PlaceWidget () override
| Methods that satisfy the superclass' API. More...
void | PlaceWidget (double xmin, double xmax, double ymin, double ymax, double zmin, double zmax) override
| Methods that satisfy the superclass' API. More...
virtual void | SetProjectToPlane (vtkTypeBool)
| Force the spline widget to be projected onto one of the orthogonal planes. More...
virtual vtkTypeBool | GetProjectToPlane ()
| Force the spline widget to be projected onto one of the orthogonal planes. More...
virtual void | ProjectToPlaneOn ()
| Force the spline widget to be projected onto one of the orthogonal planes. More...
virtual void | ProjectToPlaneOff ()
| Force the spline widget to be projected onto one of the orthogonal planes. More...
void | SetProjectionPosition (double position)
| Set the position of spline handles and points in terms of a plane's position. More...
virtual double | GetProjectionPosition ()
| Set the position of spline handles and points in terms of a plane's position. More...
virtual void | SetHandleProperty (vtkProperty *)
| Set/Get the handle properties (the spheres are the handles). More...
virtual vtkProperty * | GetHandleProperty ()
| Set/Get the handle properties (the spheres are the handles). More...
virtual void | SetSelectedHandleProperty (vtkProperty *)
| Set/Get the handle properties (the spheres are the handles). More...
virtual vtkProperty * | GetSelectedHandleProperty ()
| Set/Get the handle properties (the spheres are the handles). More...
virtual void | SetLineProperty (vtkProperty *)
| Set/Get the line properties. More...
virtual vtkProperty * | GetLineProperty ()
| Set/Get the line properties. More...
virtual void | SetSelectedLineProperty (vtkProperty *)
| Set/Get the line properties. More...
virtual vtkProperty * | GetSelectedLineProperty ()
| Set/Get the line properties. More...
virtual void | SetNumberOfHandles (int npts)
| Set/Get the number of handles for this widget. More...
virtual int | GetNumberOfHandles ()
| Set/Get the number of handles for this widget. More...
void | SetResolution (int resolution)
| Set/Get the number of line segments representing the spline for this widget. More...
virtual int | GetResolution ()
| Set/Get the number of line segments representing the spline for this widget. More...
virtual void | SetParametricSpline (vtkParametricSpline *)
| Set the parametric spline object. More...
virtual vtkParametricSpline * | GetParametricSpline ()
| Set the parametric spline object. More...
void | SetHandlePosition (int handle, double x, double y, double z)
| Set/Get the position of the spline handles. More...
void | SetHandlePosition (int handle, double xyz[3])
| Set/Get the position of the spline handles. More...
void | GetHandlePosition (int handle, double xyz[3])
| Set/Get the position of the spline handles. More...
double * | GetHandlePosition (int handle)
| Set/Get the position of the spline handles. More...
void | SetClosed (vtkTypeBool closed)
| Control whether the spline is open or closed. More...
virtual vtkTypeBool | GetClosed ()
| Control whether the spline is open or closed. More...
virtual void | ClosedOn ()
| Control whether the spline is open or closed. More...
virtual void | ClosedOff ()
| Control whether the spline is open or closed. More...
virtual void | SetProcessEvents (vtkTypeBool)
| Turn on / off event processing for this widget. More...
virtual vtkTypeBool | GetProcessEvents ()
| Turn on / off event processing for this widget. More...
virtual void | ProcessEventsOn ()
| Turn on / off event processing for this widget. More...
virtual void | ProcessEventsOff ()
| Turn on / off event processing for this widget. More...
Public Member Functions inherited from vtk3DWidget
vtk3DWidget * | NewInstance () const
virtual void | SetProp3D (vtkProp3D *)
| Specify a vtkProp3D around which to place the widget. More...
virtual vtkProp3D * | GetProp3D ()
| Specify a vtkProp3D around which to place the widget. More...
virtual void | SetInputData (vtkDataSet *)
| Specify the input dataset. More...
virtual void | SetInputConnection (vtkAlgorithmOutput *)
| Specify the input dataset. More...
virtual vtkDataSet * | GetInput ()
| Specify the input dataset. More...
virtual void | SetPlaceFactor (double)
| Set/Get a factor representing the scaling of the widget upon placement (via the PlaceWidget() method). More...
virtual double | GetPlaceFactor ()
| Set/Get a factor representing the scaling of the widget upon placement (via the PlaceWidget() method). More...
virtual void | SetHandleSize (double)
| Set/Get the factor that controls the size of the handles that appear as part of the widget. More...
virtual double | GetHandleSize ()
| Set/Get the factor that controls the size of the handles that appear as part of the widget. More...
Public Member Functions inherited from vtkInteractorObserver
vtkInteractorObserver * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
int | GetEnabled ()
void | EnabledOn ()
void | EnabledOff ()
void | On ()
void | Off ()
virtual void | OnChar ()
| Sets up the keypress-i event. More...
virtual void | SetInteractor (vtkRenderWindowInteractor *iren)
| This method is used to associate the widget with the render window interactor. More...
virtual vtkRenderWindowInteractor * | GetInteractor ()
| This method is used to associate the widget with the render window interactor. More...
virtual void | SetPriority (float)
| Set/Get the priority at which events are processed. More...
virtual float | GetPriority ()
| Set/Get the priority at which events are processed. More...
virtual void | PickingManagedOn ()
| Enable/Disable the use of a manager to process the picking. More...
virtual void | PickingManagedOff ()
| Enable/Disable the use of a manager to process the picking. More...
virtual void | SetPickingManaged (bool managed)
| Enable/Disable the use of a manager to process the picking. More...
virtual bool | GetPickingManaged ()
| Enable/Disable the use of a manager to process the picking. More...
virtual void | SetKeyPressActivation (vtkTypeBool)
| Enable/Disable of the use of a keypress to turn on and off the interactor observer. More...
virtual vtkTypeBool | GetKeyPressActivation ()
| Enable/Disable of the use of a keypress to turn on and off the interactor observer. More...
virtual void | KeyPressActivationOn ()
| Enable/Disable of the use of a keypress to turn on and off the interactor observer. More...
virtual void | KeyPressActivationOff ()
| Enable/Disable of the use of a keypress to turn on and off the interactor observer. More...
virtual void | SetKeyPressActivationValue (char)
| Specify which key press value to use to activate the interactor observer (if key press activation is enabled). More...
virtual char | GetKeyPressActivationValue ()
| Specify which key press value to use to activate the interactor observer (if key press activation is enabled). More...
virtual vtkRenderer * | GetDefaultRenderer ()
| Set/Get the default renderer to use when activating the interactor observer. More...
virtual void | SetDefaultRenderer (vtkRenderer *)
| Set/Get the default renderer to use when activating the interactor observer. More...
virtual vtkRenderer * | GetCurrentRenderer ()
| Set/Get the current renderer. More...
virtual void | SetCurrentRenderer (vtkRenderer *)
| Set/Get the current renderer. More...
void | GrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods enable an interactor observer to exclusively grab all events invoked by its associated vtkRenderWindowInteractor. More...
void | ReleaseFocus ()
| These methods enable an interactor observer to exclusively grab all events invoked by its associated vtkRenderWindowInteractor. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkSplineWidget * | New ()
| Instantiate the object. More...
static vtkTypeBool | IsTypeOf (const char *type)
static vtkSplineWidget * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtk3DWidget
static vtkTypeBool | IsTypeOf (const char *type)
static vtk3DWidget * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkInteractorObserver
static vtkTypeBool | IsTypeOf (const char *type)
static vtkInteractorObserver * | SafeDownCast (vtkObjectBase *o)
static void | ComputeDisplayToWorld (vtkRenderer *ren, double x, double y, double z, double worldPt[4])
| Convenience methods for outside classes. More...
static void | ComputeWorldToDisplay (vtkRenderer *ren, double x, double y, double z, double displayPt[3])
| Convenience methods for outside classes. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Types
enum | WidgetState { Start = 0 , Moving , Scaling , Spinning , Inserting , Erasing , Outside }

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkSplineWidget ()
| ~vtkSplineWidget () override
void | OnLeftButtonDown ()
void | OnLeftButtonUp ()
void | OnMiddleButtonDown ()
void | OnMiddleButtonUp ()
void | OnRightButtonDown ()
void | OnRightButtonUp ()
void | OnMouseMove ()
void | ProjectPointsToPlane ()
void | ProjectPointsToOrthoPlane ()
void | ProjectPointsToObliquePlane ()
void | BuildRepresentation ()
void | HighlightLine (int highlight)
void | Initialize ()
int | HighlightHandle (vtkProp *prop)
void | SizeHandles () override
void | InsertHandleOnLine (double *pos)
void | EraseHandle (const int &)
void | RegisterPickers () override
| Register internal Pickers in the Picking Manager. More...
void | MovePoint (double *p1, double *p2)
void | Scale (double *p1, double *p2, int X, int Y)
void | Translate (double *p1, double *p2)
void | Spin (double *p1, double *p2, double *vpn)
void | CreateDefaultProperties ()
void | CalculateCentroid ()
Protected Member Functions inherited from vtk3DWidget
| vtk3DWidget ()
| ~vtk3DWidget () override
void | AdjustBounds (double bounds[6], double newBounds[6], double center[3])
double | SizeHandles (double factor)
void | UpdateInput ()
Protected Member Functions inherited from vtkInteractorObserver
| vtkInteractorObserver ()
| ~vtkInteractorObserver () override
void | UnRegisterPickers ()
| Unregister internal pickers from the Picking Manager. More...
vtkPickingManager * | GetPickingManager ()
| Return the picking manager associated on the context on which the observer currently belong. More...
vtkAssemblyPath * | GetAssemblyPath (double X, double Y, double Z, vtkAbstractPropPicker *picker)
| Proceed to a pick, whether through the PickingManager if the picking is managed or directly using the picker, and return the assembly path. More...
int | RequestCursorShape (int requestedShape)
virtual void | StartInteraction ()
| Utility routines used to start and end interaction. More...
virtual void | EndInteraction ()
| Utility routines used to start and end interaction. More...
void | ComputeDisplayToWorld (double x, double y, double z, double worldPt[4])
| Helper method for subclasses. More...
void | ComputeWorldToDisplay (double x, double y, double z, double displayPt[3])
| Helper method for subclasses. More...
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Static Protected Member Functions
static void | ProcessEventsHandler (vtkObject *object, unsigned long event, void *clientdata, void *calldata)
Static Protected Member Functions inherited from vtkInteractorObserver
static void | ProcessEvents (vtkObject *object, unsigned long event, void *clientdata, void *calldata)
| Handles the char widget activation event. More...
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Protected Attributes
int | State
int | ProjectionNormal
double | ProjectionPosition
vtkTypeBool | ProjectToPlane
vtkPlaneSource * | PlaneSource
vtkParametricSpline * | ParametricSpline
vtkParametricFunctionSource * | ParametricFunctionSource
int | NumberOfHandles
vtkTypeBool | Closed
vtkActor * | LineActor
int | Resolution
vtkActor ** | Handle
vtkSphereSource ** | HandleGeometry
vtkCellPicker * | HandlePicker
vtkCellPicker * | LinePicker
vtkActor * | CurrentHandle
int | CurrentHandleIndex
vtkTransform * | Transform
vtkProperty * | HandleProperty
vtkProperty * | SelectedHandleProperty
vtkProperty * | LineProperty
vtkProperty * | SelectedLineProperty
double | Centroid [3]
vtkTypeBool | ProcessEvents
Protected Attributes inherited from vtk3DWidget
vtkProp3D * | Prop3D
vtk3DWidgetConnection * | ConnectionHolder
double | PlaceFactor
int | Placed
double | InitialBounds [6]
double | InitialLength
double | HandleSize
int | ValidPick
double | LastPickPosition [3]
Protected Attributes inherited from vtkInteractorObserver
int | Enabled
vtkCallbackCommand * | EventCallbackCommand
vtkCallbackCommand * | KeyPressCallbackCommand
float | Priority
bool | PickingManaged
vtkTypeBool | KeyPressActivation
char | KeyPressActivationValue
vtkRenderWindowInteractor * | Interactor
vtkRenderer * | CurrentRenderer
vtkRenderer * | DefaultRenderer
unsigned long | CharObserverTag
unsigned long | DeleteObserverTag
vtkObserverMediator * | ObserverMediator
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Detailed Description

3D widget for manipulating a spline

This 3D widget defines a spline that can be interactively placed in a scene. The spline has handles, the number of which can be changed, plus it can be picked on the spline itself to translate or rotate it in the scene. A nice feature of the object is that the vtkSplineWidget, like any 3D widget, will work with the current interactor style. That is, if vtkSplineWidget does not handle an event, then all other registered observers (including the interactor style) have an opportunity to process the event. Otherwise, the vtkSplineWidget will terminate the processing of the event that it handles.

To use this object, just invoke SetInteractor() with the argument of the method a vtkRenderWindowInteractor. You may also wish to invoke "PlaceWidget()" to initially position the widget. The interactor will act normally until the "i" key (for "interactor") is pressed, at which point the vtkSplineWidget will appear. (See superclass documentation for information about changing this behavior.) Events that occur outside of the widget (i.e., no part of the widget is picked) are propagated to any other registered obsevers (such as the interaction style). Turn off the widget by pressing the "i" key again (or invoke the Off() method).

The button actions and key modifiers are as follows for controlling the widget: 1) left button down on and drag one of the spherical handles to change the shape of the spline: the handles act as "control points". 2) left button or middle button down on a line segment forming the spline allows uniform translation of the widget. 3) ctrl + middle button down on the widget enables spinning of the widget about its center. 4) right button down on the widget enables scaling of the widget. By moving the mouse "up" the render window the spline will be made bigger; by moving "down" the render window the widget will be made smaller. 5) ctrl key + right button down on any handle will erase it providing there will be two or more points remaining to form a spline. 6) shift key + right button down on any line segment will insert a handle onto the spline at the cursor position.

The vtkSplineWidget has several methods that can be used in conjunction with other VTK objects. The Set/GetResolution() methods control the number of subdivisions of the spline; the GetPolyData() method can be used to get the polygonal representation and can be used for things like seeding streamlines or probing other data sets. Typical usage of the widget is to make use of the StartInteractionEvent, InteractionEvent, and EndInteractionEvent events. The InteractionEvent is called on mouse motion; the other two events are called on button down and button up (either left or right button).

Some additional features of this class include the ability to control the properties of the widget. You can set the properties of the selected and unselected representations of the spline. For example, you can set the property for the handles and spline. In addition there are methods to constrain the spline so that it is aligned with a plane. Note that a simple ruler widget can be derived by setting the resolution to 1, the number of handles to 2, and calling the GetSummedLength method!

Thanks:
  Thanks to Dean Inglis for developing and contributing this class.

See also
  vtk3DWidget vtkBoxWidget vtkLineWidget vtkPointWidget vtkSphereWidget vtkImagePlaneWidget vtkImplicitPlaneWidget vtkPlaneWidget

Events:
  vtkCommand::DisableEvent vtkCommand::EnableEvent vtkCommand::EndInteractionEvent vtkCommand::InteractionEvent vtkCommand::StartInteractionEvent

Tests:
  vtkSplineWidget (Tests)

Definition at line 99 of file vtkSplineWidget.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtk3DWidget vtkSplineWidget::Superclass

Definition at line 107 of file vtkSplineWidget.h.

## Member Enumeration Documentation

## ◆ WidgetState

enum vtkSplineWidget::WidgetState
| protected

Enumerator
Start |
Moving |
Scaling |
Spinning |
Inserting |
Erasing |
Outside |

Definition at line 286 of file vtkSplineWidget.h.

## Constructor & Destructor Documentation

## ◆ vtkSplineWidget()

vtkSplineWidget::vtkSplineWidget | ( |  | ) |
| protected

## ◆ ~vtkSplineWidget()

vtkSplineWidget::~vtkSplineWidget | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkSplineWidget* vtkSplineWidget::New | ( |  | ) |
| static

Instantiate the object.

## ◆ IsTypeOf()

static vtkTypeBool vtkSplineWidget::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkSplineWidget::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtk3DWidget.

## ◆ SafeDownCast()

static vtkSplineWidget* vtkSplineWidget::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkSplineWidget::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtk3DWidget.

## ◆ NewInstance()

vtkSplineWidget* vtkSplineWidget::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkSplineWidget::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtk3DWidget.

## ◆ SetEnabled()

void vtkSplineWidget::SetEnabled | ( | int |  | ) |
| overridevirtual

Methods that satisfy the superclass' API.

Reimplemented from vtkInteractorObserver.

## ◆ PlaceWidget() [1/3]

void vtkSplineWidget::PlaceWidget | ( | double | bounds[6] | ) |
| overridevirtual

Methods that satisfy the superclass' API.

Implements vtk3DWidget.

## ◆ PlaceWidget() [2/3]

void vtkSplineWidget::PlaceWidget | ( |  | ) |
| inlineoverridevirtual

Methods that satisfy the superclass' API.

Reimplemented from vtk3DWidget.

Definition at line 116 of file vtkSplineWidget.h.

## ◆ PlaceWidget() [3/3]

void vtkSplineWidget::PlaceWidget | ( | double | xmin,
|  | double | xmax,
|  | double | ymin,
|  | double | ymax,
|  | double | zmin,
|  | double | zmax
| ) |  |
| inlineoverridevirtual

Methods that satisfy the superclass' API.

Reimplemented from vtk3DWidget.

Definition at line 117 of file vtkSplineWidget.h.

## ◆ SetProjectToPlane()

virtual void vtkSplineWidget::SetProjectToPlane | ( | vtkTypeBool |  | ) |
| virtual

Force the spline widget to be projected onto one of the orthogonal planes.

Remember that when the state changes, a ModifiedEvent is invoked. This can be used to snap the spline to the plane if it is originally not aligned. The normal in SetProjectionNormal is 0,1,2 for YZ,XZ,XY planes respectively and 3 for arbitrary oblique planes when the widget is tied to a vtkPlaneSource.

## ◆ GetProjectToPlane()

virtual vtkTypeBool vtkSplineWidget::GetProjectToPlane | ( |  | ) |
| virtual

Force the spline widget to be projected onto one of the orthogonal planes.

Remember that when the state changes, a ModifiedEvent is invoked. This can be used to snap the spline to the plane if it is originally not aligned. The normal in SetProjectionNormal is 0,1,2 for YZ,XZ,XY planes respectively and 3 for arbitrary oblique planes when the widget is tied to a vtkPlaneSource.

## ◆ ProjectToPlaneOn()

virtual void vtkSplineWidget::ProjectToPlaneOn | ( |  | ) |
| virtual

Force the spline widget to be projected onto one of the orthogonal planes.

Remember that when the state changes, a ModifiedEvent is invoked. This can be used to snap the spline to the plane if it is originally not aligned. The normal in SetProjectionNormal is 0,1,2 for YZ,XZ,XY planes respectively and 3 for arbitrary oblique planes when the widget is tied to a vtkPlaneSource.

## ◆ ProjectToPlaneOff()

virtual void vtkSplineWidget::ProjectToPlaneOff | ( |  | ) |
| virtual

Force the spline widget to be projected onto one of the orthogonal planes.

Remember that when the state changes, a ModifiedEvent is invoked. This can be used to snap the spline to the plane if it is originally not aligned. The normal in SetProjectionNormal is 0,1,2 for YZ,XZ,XY planes respectively and 3 for arbitrary oblique planes when the widget is tied to a vtkPlaneSource.

## ◆ SetPlaneSource()

void vtkSplineWidget::SetPlaneSource | ( | vtkPlaneSource * | plane | ) |

Set up a reference to a vtkPlaneSource that could be from another widget object, e.g.

a vtkPolyDataSourceWidget.

## ◆ SetProjectionNormal()

virtual void vtkSplineWidget::SetProjectionNormal | ( | int |  | ) |
| virtual

## ◆ GetProjectionNormal()

virtual int vtkSplineWidget::GetProjectionNormal | ( |  | ) |
| virtual

## ◆ SetProjectionNormalToXAxes()

void vtkSplineWidget::SetProjectionNormalToXAxes | ( |  | ) |
| inline

Definition at line 146 of file vtkSplineWidget.h.

## ◆ SetProjectionNormalToYAxes()

void vtkSplineWidget::SetProjectionNormalToYAxes | ( |  | ) |
| inline

Definition at line 147 of file vtkSplineWidget.h.

## ◆ SetProjectionNormalToZAxes()

void vtkSplineWidget::SetProjectionNormalToZAxes | ( |  | ) |
| inline

Definition at line 148 of file vtkSplineWidget.h.

## ◆ SetProjectionNormalToOblique()

void vtkSplineWidget::SetProjectionNormalToOblique | ( |  | ) |
| inline

Definition at line 149 of file vtkSplineWidget.h.

## ◆ SetProjectionPosition()

void vtkSplineWidget::SetProjectionPosition | ( | double | position | ) |

Set the position of spline handles and points in terms of a plane's position.

i.e., if ProjectionNormal is 0, all of the x-coordinate values of the points are set to position. Any value can be passed (and is ignored) to update the spline points when Projection normal is set to 3 for arbitrary plane orientations.

## ◆ GetProjectionPosition()

virtual double vtkSplineWidget::GetProjectionPosition | ( |  | ) |
| virtual

Set the position of spline handles and points in terms of a plane's position.

i.e., if ProjectionNormal is 0, all of the x-coordinate values of the points are set to position. Any value can be passed (and is ignored) to update the spline points when Projection normal is set to 3 for arbitrary plane orientations.

## ◆ GetPolyData()

void vtkSplineWidget::GetPolyData | ( | vtkPolyData * | pd | ) |

Grab the polydata (including points) that defines the spline.

The polydata consists of points and line segments numbering Resolution + 1 and Resolution, respectively. Points are guaranteed to be up-to-date when either the InteractionEvent or EndInteraction events are invoked. The user provides the vtkPolyData and the points and polyline are added to it.

## ◆ SetHandleProperty()

virtual void vtkSplineWidget::SetHandleProperty | ( | vtkProperty * |  | ) |
| virtual

Set/Get the handle properties (the spheres are the handles).

The properties of the handles when selected and unselected can be manipulated.

## ◆ GetHandleProperty()

virtual vtkProperty* vtkSplineWidget::GetHandleProperty | ( |  | ) |
| virtual

Set/Get the handle properties (the spheres are the handles).

The properties of the handles when selected and unselected can be manipulated.

## ◆ SetSelectedHandleProperty()

virtual void vtkSplineWidget::SetSelectedHandleProperty | ( | vtkProperty * |  | ) |
| virtual

Set/Get the handle properties (the spheres are the handles).

The properties of the handles when selected and unselected can be manipulated.

## ◆ GetSelectedHandleProperty()

virtual vtkProperty* vtkSplineWidget::GetSelectedHandleProperty | ( |  | ) |
| virtual

Set/Get the handle properties (the spheres are the handles).

The properties of the handles when selected and unselected can be manipulated.

## ◆ SetLineProperty()

virtual void vtkSplineWidget::SetLineProperty | ( | vtkProperty * |  | ) |
| virtual

Set/Get the line properties.

The properties of the line when selected and unselected can be manipulated.

## ◆ GetLineProperty()

virtual vtkProperty* vtkSplineWidget::GetLineProperty | ( |  | ) |
| virtual

Set/Get the line properties.

The properties of the line when selected and unselected can be manipulated.

## ◆ SetSelectedLineProperty()

virtual void vtkSplineWidget::SetSelectedLineProperty | ( | vtkProperty * |  | ) |
| virtual

Set/Get the line properties.

The properties of the line when selected and unselected can be manipulated.

## ◆ GetSelectedLineProperty()

virtual vtkProperty* vtkSplineWidget::GetSelectedLineProperty | ( |  | ) |
| virtual

Set/Get the line properties.

The properties of the line when selected and unselected can be manipulated.

## ◆ SetNumberOfHandles()

virtual void vtkSplineWidget::SetNumberOfHandles | ( | int | npts | ) |
| virtual

Set/Get the number of handles for this widget.

## ◆ GetNumberOfHandles()

virtual int vtkSplineWidget::GetNumberOfHandles | ( |  | ) |
| virtual

Set/Get the number of handles for this widget.

## ◆ SetResolution()

void vtkSplineWidget::SetResolution | ( | int | resolution | ) |

Set/Get the number of line segments representing the spline for this widget.

## ◆ GetResolution()

virtual int vtkSplineWidget::GetResolution | ( |  | ) |
| virtual

Set/Get the number of line segments representing the spline for this widget.

## ◆ SetParametricSpline()

virtual void vtkSplineWidget::SetParametricSpline | ( | vtkParametricSpline * |  | ) |
| virtual

Set the parametric spline object.

Through vtkParametricSpline's API, the user can supply and configure one of currently two types of spline: vtkCardinalSpline, vtkKochanekSpline. The widget controls the open or closed configuration of the spline. WARNING: The widget does not enforce internal consistency so that all three are of the same type.

## ◆ GetParametricSpline()

virtual vtkParametricSpline* vtkSplineWidget::GetParametricSpline | ( |  | ) |
| virtual

Set the parametric spline object.

Through vtkParametricSpline's API, the user can supply and configure one of currently two types of spline: vtkCardinalSpline, vtkKochanekSpline. The widget controls the open or closed configuration of the spline. WARNING: The widget does not enforce internal consistency so that all three are of the same type.

## ◆ SetHandlePosition() [1/2]

void vtkSplineWidget::SetHandlePosition | ( | int | handle,
|  | double | x,
|  | double | y,
|  | double | z
| ) |  |

Set/Get the position of the spline handles.

Call GetNumberOfHandles to determine the valid range of handle indices.

## ◆ SetHandlePosition() [2/2]

void vtkSplineWidget::SetHandlePosition | ( | int | handle,
|  | double | xyz[3]
| ) |  |

Set/Get the position of the spline handles.

Call GetNumberOfHandles to determine the valid range of handle indices.

## ◆ GetHandlePosition() [1/2]

void vtkSplineWidget::GetHandlePosition | ( | int | handle,
|  | double | xyz[3]
| ) |  |

Set/Get the position of the spline handles.

Call GetNumberOfHandles to determine the valid range of handle indices.

## ◆ GetHandlePosition() [2/2]

double* vtkSplineWidget::GetHandlePosition | ( | int | handle | ) |

Set/Get the position of the spline handles.

Call GetNumberOfHandles to determine the valid range of handle indices.

## ◆ SetClosed()

void vtkSplineWidget::SetClosed | ( | vtkTypeBool | closed | ) |

Control whether the spline is open or closed.

A closed spline forms a continuous loop: the first and last points are the same, and derivatives are continuous. A minimum of 3 handles are required to form a closed loop. This method enforces consistency with user supplied subclasses of vtkSpline.

## ◆ GetClosed()

virtual vtkTypeBool vtkSplineWidget::GetClosed | ( |  | ) |
| virtual

Control whether the spline is open or closed.

A closed spline forms a continuous loop: the first and last points are the same, and derivatives are continuous. A minimum of 3 handles are required to form a closed loop. This method enforces consistency with user supplied subclasses of vtkSpline.

## ◆ ClosedOn()

virtual void vtkSplineWidget::ClosedOn | ( |  | ) |
| virtual

Control whether the spline is open or closed.

A closed spline forms a continuous loop: the first and last points are the same, and derivatives are continuous. A minimum of 3 handles are required to form a closed loop. This method enforces consistency with user supplied subclasses of vtkSpline.

## ◆ ClosedOff()

virtual void vtkSplineWidget::ClosedOff | ( |  | ) |
| virtual

Control whether the spline is open or closed.

A closed spline forms a continuous loop: the first and last points are the same, and derivatives are continuous. A minimum of 3 handles are required to form a closed loop. This method enforces consistency with user supplied subclasses of vtkSpline.

## ◆ IsClosed()

int vtkSplineWidget::IsClosed | ( |  | ) |

Convenience method to determine whether the spline is closed in a geometric sense.

The widget may be set "closed" but still be geometrically open (e.g., a straight line).

## ◆ GetSummedLength()

double vtkSplineWidget::GetSummedLength | ( |  | ) |

Get the approximate vs.

the true arc length of the spline. Calculated as the summed lengths of the individual straight line segments. Use SetResolution to control the accuracy.

## ◆ InitializeHandles()

void vtkSplineWidget::InitializeHandles | ( | vtkPoints * | points | ) |

Convenience method to allocate and set the handles from a vtkPoints instance.

If the first and last points are the same, the spline sets Closed to the on state and disregards the last point, otherwise Closed remains unchanged.

## ◆ SetProcessEvents()

virtual void vtkSplineWidget::SetProcessEvents | ( | vtkTypeBool |  | ) |
| virtual

Turn on / off event processing for this widget.

If off, the widget will not respond to user interaction

## ◆ GetProcessEvents()

virtual vtkTypeBool vtkSplineWidget::GetProcessEvents | ( |  | ) |
| virtual

Turn on / off event processing for this widget.

If off, the widget will not respond to user interaction

## ◆ ProcessEventsOn()

virtual void vtkSplineWidget::ProcessEventsOn | ( |  | ) |
| virtual

Turn on / off event processing for this widget.

If off, the widget will not respond to user interaction

## ◆ ProcessEventsOff()

virtual void vtkSplineWidget::ProcessEventsOff | ( |  | ) |
| virtual

Turn on / off event processing for this widget.

If off, the widget will not respond to user interaction

## ◆ ProcessEventsHandler()

static void vtkSplineWidget::ProcessEventsHandler | ( | vtkObject * | object,
|  | unsigned long | event,
|  | void * | clientdata,
|  | void * | calldata
| ) |  |
| staticprotected

## ◆ OnLeftButtonDown()

void vtkSplineWidget::OnLeftButtonDown | ( |  | ) |
| protected

## ◆ OnLeftButtonUp()

void vtkSplineWidget::OnLeftButtonUp | ( |  | ) |
| protected

## ◆ OnMiddleButtonDown()

void vtkSplineWidget::OnMiddleButtonDown | ( |  | ) |
| protected

## ◆ OnMiddleButtonUp()

void vtkSplineWidget::OnMiddleButtonUp | ( |  | ) |
| protected

## ◆ OnRightButtonDown()

void vtkSplineWidget::OnRightButtonDown | ( |  | ) |
| protected

## ◆ OnRightButtonUp()

void vtkSplineWidget::OnRightButtonUp | ( |  | ) |
| protected

## ◆ OnMouseMove()

void vtkSplineWidget::OnMouseMove | ( |  | ) |
| protected

## ◆ ProjectPointsToPlane()

void vtkSplineWidget::ProjectPointsToPlane | ( |  | ) |
| protected

## ◆ ProjectPointsToOrthoPlane()

void vtkSplineWidget::ProjectPointsToOrthoPlane | ( |  | ) |
| protected

## ◆ ProjectPointsToObliquePlane()

void vtkSplineWidget::ProjectPointsToObliquePlane | ( |  | ) |
| protected

## ◆ BuildRepresentation()

void vtkSplineWidget::BuildRepresentation | ( |  | ) |
| protected

## ◆ HighlightLine()

void vtkSplineWidget::HighlightLine | ( | int | highlight | ) |
| protected

## ◆ Initialize()

void vtkSplineWidget::Initialize | ( |  | ) |
| protected

## ◆ HighlightHandle()

int vtkSplineWidget::HighlightHandle | ( | vtkProp * | prop | ) |
| protected

## ◆ SizeHandles()

void vtkSplineWidget::SizeHandles | ( |  | ) |
| overrideprotectedvirtual

Reimplemented from vtk3DWidget.

## ◆ InsertHandleOnLine()

void vtkSplineWidget::InsertHandleOnLine | ( | double * | pos | ) |
| protected

## ◆ EraseHandle()

void vtkSplineWidget::EraseHandle | ( | const int & |  | ) |
| protected

## ◆ RegisterPickers()

void vtkSplineWidget::RegisterPickers | ( |  | ) |
| overrideprotectedvirtual

Register internal Pickers in the Picking Manager.

Must be reimplemented by concrete widgets to register their pickers.

Reimplemented from vtkInteractorObserver.

## ◆ MovePoint()

void vtkSplineWidget::MovePoint | ( | double * | p1,
|  | double * | p2
| ) |  |
| protected

## ◆ Scale()

void vtkSplineWidget::Scale | ( | double * | p1,
|  | double * | p2,
|  | int | X,
|  | int | Y
| ) |  |
| protected

## ◆ Translate()

void vtkSplineWidget::Translate | ( | double * | p1,
|  | double * | p2
| ) |  |
| protected

## ◆ Spin()

void vtkSplineWidget::Spin | ( | double * | p1,
|  | double * | p2,
|  | double * | vpn
| ) |  |
| protected

## ◆ CreateDefaultProperties()

void vtkSplineWidget::CreateDefaultProperties | ( |  | ) |
| protected

## ◆ CalculateCentroid()

void vtkSplineWidget::CalculateCentroid | ( |  | ) |
| protected

## Member Data Documentation

## ◆ State

int vtkSplineWidget::State
| protected

Definition at line 285 of file vtkSplineWidget.h.

## ◆ ProjectionNormal

int vtkSplineWidget::ProjectionNormal
| protected

Definition at line 311 of file vtkSplineWidget.h.

## ◆ ProjectionPosition

double vtkSplineWidget::ProjectionPosition
| protected

Definition at line 312 of file vtkSplineWidget.h.

## ◆ ProjectToPlane

vtkTypeBool vtkSplineWidget::ProjectToPlane
| protected

Definition at line 313 of file vtkSplineWidget.h.

## ◆ PlaneSource

vtkPlaneSource* vtkSplineWidget::PlaneSource
| protected

Definition at line 314 of file vtkSplineWidget.h.

## ◆ ParametricSpline

vtkParametricSpline* vtkSplineWidget::ParametricSpline
| protected

Definition at line 322 of file vtkSplineWidget.h.

## ◆ ParametricFunctionSource

vtkParametricFunctionSource* vtkSplineWidget::ParametricFunctionSource
| protected

Definition at line 323 of file vtkSplineWidget.h.

## ◆ NumberOfHandles

int vtkSplineWidget::NumberOfHandles
| protected

Definition at line 324 of file vtkSplineWidget.h.

## ◆ Closed

vtkTypeBool vtkSplineWidget::Closed
| protected

Definition at line 325 of file vtkSplineWidget.h.

## ◆ LineActor

vtkActor* vtkSplineWidget::LineActor
| protected

Definition at line 329 of file vtkSplineWidget.h.

## ◆ Resolution

int vtkSplineWidget::Resolution
| protected

Definition at line 331 of file vtkSplineWidget.h.

## ◆ Handle

vtkActor** vtkSplineWidget::Handle
| protected

Definition at line 334 of file vtkSplineWidget.h.

## ◆ HandleGeometry

vtkSphereSource** vtkSplineWidget::HandleGeometry
| protected

Definition at line 335 of file vtkSplineWidget.h.

## ◆ HandlePicker

vtkCellPicker* vtkSplineWidget::HandlePicker
| protected

Definition at line 343 of file vtkSplineWidget.h.

## ◆ LinePicker

vtkCellPicker* vtkSplineWidget::LinePicker
| protected

Definition at line 344 of file vtkSplineWidget.h.

## ◆ CurrentHandle

vtkActor* vtkSplineWidget::CurrentHandle
| protected

Definition at line 345 of file vtkSplineWidget.h.

## ◆ CurrentHandleIndex

int vtkSplineWidget::CurrentHandleIndex
| protected

Definition at line 346 of file vtkSplineWidget.h.

## ◆ Transform

vtkTransform* vtkSplineWidget::Transform
| protected

Definition at line 358 of file vtkSplineWidget.h.

## ◆ HandleProperty

vtkProperty* vtkSplineWidget::HandleProperty
| protected

Definition at line 362 of file vtkSplineWidget.h.

## ◆ SelectedHandleProperty

vtkProperty* vtkSplineWidget::SelectedHandleProperty
| protected

Definition at line 363 of file vtkSplineWidget.h.

## ◆ LineProperty

vtkProperty* vtkSplineWidget::LineProperty
| protected

Definition at line 364 of file vtkSplineWidget.h.

## ◆ SelectedLineProperty

vtkProperty* vtkSplineWidget::SelectedLineProperty
| protected

Definition at line 365 of file vtkSplineWidget.h.

## ◆ Centroid

double vtkSplineWidget::Centroid[3]
| protected

Definition at line 369 of file vtkSplineWidget.h.

## ◆ ProcessEvents

vtkTypeBool vtkSplineWidget::ProcessEvents
| protected

Definition at line 371 of file vtkSplineWidget.h.

The documentation for this class was generated from the following file:

- Interaction/Widgets/vtkSplineWidget.h